---
title: XRInputSourceEventInit.frame
slug: Web/API/XRInputSourceEventInit/frame
tags:
  - API
  - AR
  - Augmetned
  - Configuration
  - Dictionary
  - Frame
  - Input
  - Input Source
  - Mixed
  - Options
  - Reality
  - Reference
  - Settings
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRInputSourceEventInit
  - source
---
<p>{{APIRef("WebXR Device API")}} {{SecureContext_Header}}</p>

<p><span class="seoSummary">The {{domxref("XRInputSourceEventInit")}} dictionary's property <code><strong>frame</strong></code> specifies an {{domxref("XRFrame")}} providing information about the timestamp at which the new input source event took place, as well as access to the {{domxref("XRFrame")}} method {{domxref("XRFrame.getPose", "getPose()")}} which can be used to map the coordinates of any {{domxref("XRReferenceSpace")}} to the space in which the event took place.</span></p>

<p>Of course, as a general rule, you won't need to create <code>XRInputSourceEventInit</code> objects yourself. These events are generated by and sent to you by the WebXR infrastructure.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>xrInputSourceEventInit</em>.frame = <em>xrFrame</em>;

let <em>xrInputSourceEventInit</em> = { frame: <em>xrFrame</em> };

let <em>xrInputSourceEvent</em> = new XRInputSourceEvent(<em>type</em>, { frame: <em>xrFrame</em> });</pre>

<h3 id="Value">Value</h3>

<p>An {{domxref("XRFrame")}} indicating the time at which the event took place, and providing a <code>getPose()</code> method which can be used to map reference spaces to the world reference space.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>The event frame does not correspond to a visual frame as is delivered to the frame rendering callback function (see <a href="/en-US/docs/Web/API/WebXR_Device_API/Rendering">Rendering and the WebXR frame rendering callback</a> for details on the callback). Instead, the <code>XRFrame</code> specified by the <code>frame</code> property is a method to provide access to the {{domxref("XRFrame.getPose", "getPose()")}} method, which you can use to get the relative positions of the objects in the scene at the time the event occurred.</p>

<h2 id="Examples">Examples</h2>

<p>This example creates a new {{domxref("XRSession.select_event", "select")}} event and sends it to the {{domxref("XRSession")}}.</p>

<pre class="brush: js">let event = new XRInputSourceEvent("select", {
  frame: eventFrame,
  inputSource: source
};
if (event) {
  xrSession.dispatchEvent(event);
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrinputsourceeventinit-frame","XRInputSourceEventInit.frame")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRInputSourceEventInit.frame")}}</div>
